/* beautiful-react-hooks version: 0.28.0 */
import { slicedToArray as _slicedToArray } from './_virtual/_rollupPluginBabelHelpers.js';
import { useState } from 'react';
import useGlobalEvent from './useGlobalEvent.js';

var useOnlineState = function useOnlineState() {
  var isSupported = typeof window !== 'undefined' && 'ononline' in window;

  var _useState = useState(isSupported ? navigator.onLine : true),
      _useState2 = _slicedToArray(_useState, 2),
      isOnline = _useState2[0],
      setIsOnline = _useState2[1];

  var whenOnline = useGlobalEvent('online', {
    capture: true
  });
  var whenOffline = useGlobalEvent('offline', {
    capture: true
  });

  if (!isSupported) {
    console.warn('The current device does not support the \'online/offline\' events, you should avoid using useOnlineState');
    return isOnline;
  }

  whenOnline(function () {
    setIsOnline(true);
  });
  whenOffline(function () {
    setIsOnline(false);
  });
  return isOnline;
};

export default useOnlineState;
