/* beautiful-react-hooks version: 0.28.0 */
import { slicedToArray as _slicedToArray } from './_virtual/_rollupPluginBabelHelpers.js';
import { useState, useRef, useCallback } from 'react';

var useValidatedState = function useValidatedState(validator, initialValue) {
  var _useState = useState(initialValue),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var validation = useRef({
    changed: false
  });
  var onChange = useCallback(function (nextValue) {
    setState(nextValue);
    validation.current = {
      changed: true,
      valid: validator(nextValue)
    };
  }, [validator]);
  return [state, onChange, validation.current];
};

export default useValidatedState;
