/* beautiful-react-hooks version: 0.28.0 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('./_virtual/_rollupPluginBabelHelpers.js');
var react = require('react');

var maybeState = function maybeState(state, defaultValue) {
  return state === null || state === undefined ? defaultValue : state;
};

var useDefaultedState = function useDefaultedState(defaultValue, initialState) {
  var _useState = react.useState(maybeState(initialState, defaultValue)),
      _useState2 = _rollupPluginBabelHelpers.slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  var setStateSafe = function setStateSafe(nextState) {
    return setState(maybeState(nextState, defaultValue));
  };

  return [maybeState(state, defaultValue), setStateSafe];
};

exports.default = useDefaultedState;
