/* beautiful-react-hooks version: 0.28.0 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('./_virtual/_rollupPluginBabelHelpers.js');
var react = require('react');
var createHandlerSetter = require('./utils/createHandlerSetter.js');

var useWillUnmount = function useWillUnmount(handler) {
  var _createHandlerSetter = createHandlerSetter.default(handler),
      _createHandlerSetter2 = _rollupPluginBabelHelpers.slicedToArray(_createHandlerSetter, 2),
      onUnmountHandler = _createHandlerSetter2[0],
      setOnUnmount = _createHandlerSetter2[1];

  react.useEffect(function () {
    return function () {
      if (onUnmountHandler.current) {
        onUnmountHandler.current();
      }
    };
  }, []);
  return setOnUnmount;
};

exports.default = useWillUnmount;
