/* beautiful-react-hooks version: 0.28.0 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');

var createHandlerSetter = function createHandlerSetter(handlerValue) {
  var handlerRef = react.useRef(handlerValue);
  handlerRef.current = handlerValue;
  var setHandler = react.useCallback(function (nextCallback) {
    if (typeof nextCallback !== 'function') {
      throw new Error('the argument supplied to the \'setHandler\' function should be of type function');
    }

    handlerRef.current = nextCallback;
  });
  return [handlerRef, setHandler];
};

exports.default = createHandlerSetter;
